"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DurationPickerWidgetConfigureComponent = exports.DurationPickerWidgetConfigureChange = exports.TANJ_DURATION_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = void 0;
const core_1 = require("@angular/core");
const forms_1 = require("@angular/forms");
const core_2 = require("@tangential/core");
const moment = require("moment");
const duration_picker_state_1 = require("./duration-picker-state");
const i0 = require("@angular/core");
const i1 = require("@angular/common");
const i2 = require("@angular/forms");
const i3 = require("@angular/material/form-field");
const i4 = require("@angular/material/input");
const i5 = require("@angular/material/checkbox");
const i6 = require("./duration-picker-widget.component");
function DurationPickerWidgetConfigureComponent_ng_container_3_mat_checkbox_5_Template(rf, ctx) { if (rf & 1) {
    const _r4 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "mat-checkbox", 8);
    i0.ɵɵlistener("change", function DurationPickerWidgetConfigureComponent_ng_container_3_mat_checkbox_5_Template_mat_checkbox_change_0_listener($event) { const restoredCtx = i0.ɵɵrestoreView(_r4); const field_r2 = restoredCtx.$implicit; return i0.ɵɵresetView(field_r2.selected = $event.checked); });
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const field_r2 = ctx.$implicit;
    i0.ɵɵproperty("disabled", !field_r2.canToggleSelection())("labelPosition", "before")("checked", field_r2.selected);
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate1(" ", field_r2.unit.fullLabel, " ");
} }
function DurationPickerWidgetConfigureComponent_ng_container_3_Template(rf, ctx) { if (rf & 1) {
    const _r6 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementContainerStart(0);
    i0.ɵɵelementStart(1, "fieldset", 4)(2, "legend");
    i0.ɵɵtext(3, "For:");
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(4, "div", 5);
    i0.ɵɵtemplate(5, DurationPickerWidgetConfigureComponent_ng_container_3_mat_checkbox_5_Template, 2, 4, "mat-checkbox", 6);
    i0.ɵɵelementEnd()();
    i0.ɵɵelementStart(6, "tanj-duration-picker-widget", 7);
    i0.ɵɵlistener("valueChange", function DurationPickerWidgetConfigureComponent_ng_container_3_Template_tanj_duration_picker_widget_valueChange_6_listener($event) { i0.ɵɵrestoreView(_r6); const ctx_r5 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r5.defaultValue = $event); })("valueChange", function DurationPickerWidgetConfigureComponent_ng_container_3_Template_tanj_duration_picker_widget_valueChange_6_listener() { i0.ɵɵrestoreView(_r6); const ctx_r7 = i0.ɵɵnextContext(); ctx_r7.value = ctx_r7.defaultValue; ctx_r7.valueChange.emit(ctx_r7.value); return i0.ɵɵresetView(ctx_r7.defaultValueChange.emit(ctx_r7.defaultValue)); });
    i0.ɵɵelementEnd();
    i0.ɵɵelementContainerEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance(5);
    i0.ɵɵproperty("ngForOf", ctx_r0.state.fields);
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("value", ctx_r0.defaultValue)("defaultValue", ctx_r0.defaultValue)("showDays", ctx_r0.showDays)("showHours", ctx_r0.showHours)("showMinutes", ctx_r0.showMinutes)("showSeconds", ctx_r0.showSeconds)("showMilliseconds", ctx_r0.showMilliseconds)("max", ctx_r0.max)("labelPosition", "before");
} }
/**
 * Provider Expression that allows IconRatingWidget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_DURATION_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: (0, core_1.forwardRef)(() => DurationPickerWidgetConfigureComponent),
    multi: true
};
class DurationPickerWidgetConfigureChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
exports.DurationPickerWidgetConfigureChange = DurationPickerWidgetConfigureChange;
class DurationPickerWidgetConfigureComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.labelChange = new core_1.EventEmitter(false);
        this.defaultValue = 0;
        this.defaultValueChange = new core_1.EventEmitter(false);
        this.max = 100;
        this.maxChange = new core_1.EventEmitter(false);
        this.showDays = false;
        this.showDaysChange = new core_1.EventEmitter(false);
        this.showHours = false;
        this.showHoursChange = new core_1.EventEmitter(false);
        this.showMinutes = false;
        this.showMinutesChange = new core_1.EventEmitter(false);
        this.showSeconds = false;
        this.showSecondsChange = new core_1.EventEmitter(false);
        this.showMilliseconds = false;
        this.showMillisecondsChange = new core_1.EventEmitter(false);
        /* end Configuration Fields */
        this.state = new duration_picker_state_1.DurationPickerState();
        this.change = new core_1.EventEmitter(false);
        /**
         * Called when the spinner is blurred. Needed to properly implement ControlValueAccessor.
         * @docs-private
         */
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
        if (changes.value) {
            this.state.setDuration(moment.duration(this.value));
        }
        this.updateFields();
    }
    updateFields() {
        if (this.showDays) {
            this.state.select(core_2.TimeUnits.day);
        }
        if (this.showHours) {
            this.state.select(core_2.TimeUnits.h);
        }
        if (this.showMinutes) {
            this.state.select(core_2.TimeUnits.min);
        }
        if (this.showSeconds) {
            this.state.select(core_2.TimeUnits.s);
        }
        if (this.showMilliseconds) {
            this.state.select(core_2.TimeUnits.ms);
        }
    }
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new DurationPickerWidgetConfigureChange(this, this.value));
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
exports.DurationPickerWidgetConfigureComponent = DurationPickerWidgetConfigureComponent;
DurationPickerWidgetConfigureComponent.ɵfac = function DurationPickerWidgetConfigureComponent_Factory(t) { return new (t || DurationPickerWidgetConfigureComponent)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef)); };
DurationPickerWidgetConfigureComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: DurationPickerWidgetConfigureComponent, selectors: [["tanj-duration-picker-widget-configure"]], hostVars: 3, hostBindings: function DurationPickerWidgetConfigureComponent_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵattribute("flex", ctx.flex)("layout", ctx.flexLayout)("layout-align", ctx.flexLayoutAlign);
    } }, inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", label: "label", defaultValue: "defaultValue", max: "max", showDays: "showDays", showHours: "showHours", showMinutes: "showMinutes", showSeconds: "showSeconds", showMilliseconds: "showMilliseconds" }, outputs: { valueChange: "valueChange", labelChange: "labelChange", defaultValueChange: "defaultValueChange", maxChange: "maxChange", showDaysChange: "showDaysChange", showHoursChange: "showHoursChange", showMinutesChange: "showMinutesChange", showSecondsChange: "showSecondsChange", showMillisecondsChange: "showMillisecondsChange", change: "change" }, features: [i0.ɵɵProvidersFeature([exports.TANJ_DURATION_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR]), i0.ɵɵNgOnChangesFeature], decls: 4, vars: 2, consts: [["flex", "", "layout", "column", "layout-align", "start", 1, "tanj-input-template", "tanj-mode-configure"], ["dividerColor", "accent"], ["matInput", "", "type", "text", "maxlength", "50", "placeholder", "Enter a label for this input", 1, "tanj-input", 3, "ngModel", "change", "ngModelChange"], [4, "ngIf"], ["flex", "", "layout", "row", "layout-align", "start"], ["flex", "", "layout", "column", "layout-align", "start", 1, "tanj-choose-duration-fields-container"], ["layout", "row", "layout-align", "start", 3, "disabled", "labelPosition", "checked", "change", 4, "ngFor", "ngForOf"], ["label", "Default Value", 3, "value", "defaultValue", "showDays", "showHours", "showMinutes", "showSeconds", "showMilliseconds", "max", "labelPosition", "valueChange"], ["layout", "row", "layout-align", "start", 3, "disabled", "labelPosition", "checked", "change"]], template: function DurationPickerWidgetConfigureComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementStart(0, "div", 0)(1, "mat-form-field", 1)(2, "input", 2);
        i0.ɵɵlistener("change", function DurationPickerWidgetConfigureComponent_Template_input_change_2_listener() { return ctx.labelChange.emit(ctx.label); })("ngModelChange", function DurationPickerWidgetConfigureComponent_Template_input_ngModelChange_2_listener($event) { return ctx.label = $event; });
        i0.ɵɵelementEnd()();
        i0.ɵɵtemplate(3, DurationPickerWidgetConfigureComponent_ng_container_3_Template, 7, 10, "ng-container", 3);
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngModel", ctx.label);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", ctx.label);
    } }, dependencies: [i1.NgForOf, i1.NgIf, i2.DefaultValueAccessor, i2.NgControlStatus, i2.MaxLengthValidator, i2.NgModel, i3.MatFormField, i4.MatInput, i5.MatCheckbox, i6.DurationPickerWidgetComponent], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(DurationPickerWidgetConfigureComponent, [{
        type: core_1.Component,
        args: [{
                selector: 'tanj-duration-picker-widget-configure',
                template: `<!--  -->
  <div class="tanj-input-template tanj-mode-configure" flex layout="column" layout-align="start">
    <mat-form-field dividerColor="accent">
      <input matInput
             class="tanj-input"
             type="text"
             maxlength="50"
             placeholder="Enter a label for this input"
             (change)="labelChange.emit(label)"
             [(ngModel)]="label"/>
    </mat-form-field>

    <ng-container *ngIf="label">
      <fieldset flex layout="row" layout-align="start">
        <legend>For:</legend>
        <div flex class="tanj-choose-duration-fields-container" layout="column" layout-align="start">
          <mat-checkbox *ngFor="let field of state.fields"
                       layout="row" layout-align="start"
                       [disabled]="!field.canToggleSelection()"
                       [labelPosition]="'before'"
                       [checked]="field.selected"
                       (change)="field.selected = $event.checked">
            {{field.unit.fullLabel}}
          </mat-checkbox>
        </div>
      </fieldset>

      <tanj-duration-picker-widget
        [(value)]="defaultValue"
        (valueChange)="value = defaultValue; valueChange.emit(value); defaultValueChange.emit(defaultValue)"
        [defaultValue]="defaultValue"
        [showDays]="showDays"
        [showHours]="showHours"
        [showMinutes]="showMinutes"
        [showSeconds]="showSeconds"
        [showMilliseconds]="showMilliseconds"
        [max]="max"
        label="Default Value"
        [labelPosition]="'before'">
      </tanj-duration-picker-widget>
    </ng-container>

  </div>
                 `,
                providers: [exports.TANJ_DURATION_WIDGET_CONFIG_CONTROL_VALUE_ACCESSOR],
                encapsulation: core_1.ViewEncapsulation.None
            }]
    }], function () { return [{ type: i0.ChangeDetectorRef }]; }, { flex: [{
            type: core_1.HostBinding,
            args: ['attr.flex']
        }], flexLayout: [{
            type: core_1.HostBinding,
            args: ['attr.layout']
        }], flexLayoutAlign: [{
            type: core_1.HostBinding,
            args: ['attr.layout-align']
        }], value: [{
            type: core_1.Input
        }], valueChange: [{
            type: core_1.Output
        }], labelPosition: [{
            type: core_1.Input
        }], disabled: [{
            type: core_1.Input
        }], label: [{
            type: core_1.Input
        }], labelChange: [{
            type: core_1.Output
        }], defaultValue: [{
            type: core_1.Input
        }], defaultValueChange: [{
            type: core_1.Output
        }], max: [{
            type: core_1.Input
        }], maxChange: [{
            type: core_1.Output
        }], showDays: [{
            type: core_1.Input
        }], showDaysChange: [{
            type: core_1.Output
        }], showHours: [{
            type: core_1.Input
        }], showHoursChange: [{
            type: core_1.Output
        }], showMinutes: [{
            type: core_1.Input
        }], showMinutesChange: [{
            type: core_1.Output
        }], showSeconds: [{
            type: core_1.Input
        }], showSecondsChange: [{
            type: core_1.Output
        }], showMilliseconds: [{
            type: core_1.Input
        }], showMillisecondsChange: [{
            type: core_1.Output
        }], change: [{
            type: core_1.Output
        }] }); })();
//# sourceMappingURL=duration-picker-widget-configure.component.js.map