"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberSliderWidgetComponent = exports.NumberSliderWidgetChange = exports.TANJ_NUMBER_SLIDER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = void 0;
const core_1 = require("@angular/core");
const forms_1 = require("@angular/forms");
const core_2 = require("@tangential/core");
const i0 = require("@angular/core");
const i1 = require("@angular/common");
const i2 = require("@angular/forms");
const i3 = require("@angular/material/form-field");
const i4 = require("@angular/material/input");
const i5 = require("@angular/material/slider");
function NumberSliderWidgetComponent_span_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 6);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r0.label);
} }
function NumberSliderWidgetComponent_div_3_Template(rf, ctx) { if (rf & 1) {
    const _r5 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 7)(1, "mat-slider", 8);
    i0.ɵɵlistener("ngModelChange", function NumberSliderWidgetComponent_div_3_Template_mat_slider_ngModelChange_1_listener($event) { i0.ɵɵrestoreView(_r5); const ctx_r4 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r4.value = $event); })("change", function NumberSliderWidgetComponent_div_3_Template_mat_slider_change_1_listener() { i0.ɵɵrestoreView(_r5); const ctx_r6 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r6.valueChange.emit(ctx_r6.value)); });
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(2, "mat-form-field", 9)(3, "input", 10);
    i0.ɵɵlistener("change", function NumberSliderWidgetComponent_div_3_Template_input_change_3_listener() { i0.ɵɵrestoreView(_r5); const ctx_r7 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r7.valueChange.emit(ctx_r7.value)); })("ngModelChange", function NumberSliderWidgetComponent_div_3_Template_input_ngModelChange_3_listener($event) { i0.ɵɵrestoreView(_r5); const ctx_r8 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r8.value = $event); });
    i0.ɵɵelementEnd()()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("disabled", ctx_r1.disabled)("ngModel", ctx_r1.value)("max", ctx_r1.max)("min", ctx_r1.min)("step", ctx_r1.step)("thumbLabel", true)("tickInterval", ctx_r1.tickInterval)("vertical", ctx_r1.vertical);
    i0.ɵɵadvance(2);
    i0.ɵɵpropertyInterpolate("max", ctx_r1.max);
    i0.ɵɵproperty("disabled", ctx_r1.disabled)("step", ctx_r1.step)("ngModel", ctx_r1.value);
} }
function NumberSliderWidgetComponent_span_4_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 11);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r2 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r2.label);
} }
function NumberSliderWidgetComponent_span_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 12);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r3 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r3.label);
} }
const _c0 = function (a0) { return { "tanj-disabled": a0 }; };
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_NUMBER_SLIDER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR, useExisting: (0, core_1.forwardRef)(() => NumberSliderWidgetComponent), multi: true
};
class NumberSliderWidgetChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
exports.NumberSliderWidgetChange = NumberSliderWidgetChange;
class NumberSliderWidgetComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'below';
        this.disabled = false;
        this.hideLabel = false;
        this.onlyLabel = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 5;
        this.min = 0;
        this.step = 1;
        this.decimalPlaces = 1;
        this.tickInterval = 1;
        this.vertical = false;
        /* end Configuration Fields */
        this.change = new core_1.EventEmitter(false);
        this.onTouched = () => {
        };
        this.controlValueAccessorChangeFn = (value) => {
        };
    }
    ngOnInit() {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
    }
    handleValueChange(value) {
        if (!this.disabled) {
            this.value = value;
            this.valueChange.emit(this.value);
            this.emitChangeEvent();
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    emitChangeEvent() {
        const change = new NumberSliderWidgetChange(this, this.value);
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(change);
    }
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
exports.NumberSliderWidgetComponent = NumberSliderWidgetComponent;
NumberSliderWidgetComponent.ɵfac = function NumberSliderWidgetComponent_Factory(t) { return new (t || NumberSliderWidgetComponent)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef)); };
NumberSliderWidgetComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: NumberSliderWidgetComponent, selectors: [["tanj-number-slider-widget"]], hostVars: 3, hostBindings: function NumberSliderWidgetComponent_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵattribute("flex", ctx.flex)("layout", ctx.flexLayout)("layout-align", ctx.flexLayoutAlign);
    } }, inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", hideLabel: "hideLabel", onlyLabel: "onlyLabel", label: "label", defaultValue: "defaultValue", max: "max", min: "min", step: "step", decimalPlaces: "decimalPlaces", tickInterval: "tickInterval", vertical: "vertical" }, outputs: { valueChange: "valueChange", change: "change" }, features: [i0.ɵɵProvidersFeature([exports.TANJ_NUMBER_SLIDER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR]), i0.ɵɵNgOnChangesFeature], decls: 6, vars: 7, consts: [["flex", "", "layout", "row", "layout-align", "center center", 1, "tanj-input-template", "tanj-mode-edit", 3, "ngClass"], ["class", "tanj-label tanj-before", 4, "ngIf"], ["flex", "", "layout", "column", "layout-align", "start center", 1, "tanj-widget-input-container"], ["flex", "", "class", "tanj-widget-input", "layout", "row", "layout-align", "start", 4, "ngIf"], ["class", "tanj-label tanj-below", 4, "ngIf"], ["class", "tanj-label tanj-after", 4, "ngIf"], [1, "tanj-label", "tanj-before"], ["flex", "", "layout", "row", "layout-align", "start", 1, "tanj-widget-input"], ["flex", "", 3, "disabled", "ngModel", "max", "min", "step", "thumbLabel", "tickInterval", "vertical", "ngModelChange", "change"], ["flex", "15", "dividerColor", "accent", "layout", "row", "layout-align", "start", 1, "tanj-number-slider-input-field", "tanj-widget-input"], ["flex", "", "matInput", "", "type", "number", 1, "tanj-input", 3, "max", "disabled", "step", "ngModel", "change", "ngModelChange"], [1, "tanj-label", "tanj-below"], [1, "tanj-label", "tanj-after"]], template: function NumberSliderWidgetComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementStart(0, "div", 0);
        i0.ɵɵtemplate(1, NumberSliderWidgetComponent_span_1_Template, 2, 1, "span", 1);
        i0.ɵɵelementStart(2, "div", 2);
        i0.ɵɵtemplate(3, NumberSliderWidgetComponent_div_3_Template, 4, 12, "div", 3);
        i0.ɵɵtemplate(4, NumberSliderWidgetComponent_span_4_Template, 2, 1, "span", 4);
        i0.ɵɵelementEnd();
        i0.ɵɵtemplate(5, NumberSliderWidgetComponent_span_5_Template, 2, 1, "span", 5);
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction1(5, _c0, ctx.disabled));
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", !ctx.hideLabel && ctx.labelPosition == "before");
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngIf", !ctx.onlyLabel);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", !ctx.hideLabel && ctx.labelPosition == "below");
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", !ctx.hideLabel && ctx.labelPosition == "after");
    } }, dependencies: [i1.NgClass, i1.NgIf, i2.DefaultValueAccessor, i2.NumberValueAccessor, i2.NgControlStatus, i2.MaxValidator, i2.NgModel, i3.MatFormField, i4.MatInput, i5.MatSlider], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(NumberSliderWidgetComponent, [{
        type: core_1.Component,
        args: [{
                selector: 'tanj-number-slider-widget', template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="center center">
    <span *ngIf="!hideLabel && labelPosition == 'before'"
          class="tanj-label tanj-before">{{label}}</span>
    <div flex class="tanj-widget-input-container" layout="column" layout-align="start center">
      <div flex *ngIf="!onlyLabel" class="tanj-widget-input" layout="row" layout-align="start">
        <mat-slider flex
                   [disabled]="disabled"
                   [(ngModel)]="value"
                   (change)="valueChange.emit(value)"
                   [max]="max"
                   [min]="min"
                   [step]="step"
                   [thumbLabel]="true"
                   [tickInterval]="tickInterval"
                   [vertical]="vertical">
        </mat-slider>
        <mat-form-field flex="15"
                            class="tanj-number-slider-input-field tanj-widget-input"
                            dividerColor="accent"
                            layout="row"
                            layout-align="start">
          <input flex
                 matInput
                 class="tanj-input"
                 type="number"
                 max="{{max}}"
                 [disabled]="disabled"
                 [step]="step"
                 (change)="valueChange.emit(value)"
                 [(ngModel)]="value"/>
        </mat-form-field>
      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after">{{label}}</span>
  </div>
            `, providers: [exports.TANJ_NUMBER_SLIDER_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR], encapsulation: core_1.ViewEncapsulation.None
            }]
    }], function () { return [{ type: i0.ChangeDetectorRef }]; }, { flex: [{
            type: core_1.HostBinding,
            args: ['attr.flex']
        }], flexLayout: [{
            type: core_1.HostBinding,
            args: ['attr.layout']
        }], flexLayoutAlign: [{
            type: core_1.HostBinding,
            args: ['attr.layout-align']
        }], value: [{
            type: core_1.Input
        }], valueChange: [{
            type: core_1.Output
        }], labelPosition: [{
            type: core_1.Input
        }], disabled: [{
            type: core_1.Input
        }], hideLabel: [{
            type: core_1.Input
        }], onlyLabel: [{
            type: core_1.Input
        }], label: [{
            type: core_1.Input
        }], defaultValue: [{
            type: core_1.Input
        }], max: [{
            type: core_1.Input
        }], min: [{
            type: core_1.Input
        }], step: [{
            type: core_1.Input
        }], decimalPlaces: [{
            type: core_1.Input
        }], tickInterval: [{
            type: core_1.Input
        }], vertical: [{
            type: core_1.Input
        }], change: [{
            type: core_1.Output
        }] }); })();
//# sourceMappingURL=number-slider-widget.component.js.map