"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DurationPickerDialog = exports.DurationPickerDialogResult = void 0;
const core_1 = require("@angular/core");
const dialog_1 = require("@angular/material/dialog");
const i0 = require("@angular/core");
const i1 = require("@angular/material/dialog");
const i2 = require("@angular/common");
const i3 = require("@angular/forms");
const i4 = require("../number-spinner-widget/number-spinner-widget.component");
function DurationPickerDialog_tanj_number_spinner_widget_2_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "tanj-number-spinner-widget", 7);
    i0.ɵɵlistener("ngModelChange", function DurationPickerDialog_tanj_number_spinner_widget_2_Template_tanj_number_spinner_widget_ngModelChange_0_listener($event) { const restoredCtx = i0.ɵɵrestoreView(_r3); const field_r1 = restoredCtx.$implicit; return i0.ɵɵresetView(field_r1.value = $event); })("change", function DurationPickerDialog_tanj_number_spinner_widget_2_Template_tanj_number_spinner_widget_change_0_listener() { const restoredCtx = i0.ɵɵrestoreView(_r3); const field_r1 = restoredCtx.$implicit; const ctx_r4 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r4.onValueChange(field_r1)); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const field_r1 = ctx.$implicit;
    i0.ɵɵproperty("ngModel", field_r1.value)("label", field_r1.label)("labelPosition", "below")("max", field_r1.max)("min", 0);
} }
class DurationPickerDialogResult {
    constructor() {
        this.success = false;
        this.millis = 0;
    }
}
exports.DurationPickerDialogResult = DurationPickerDialogResult;
class DurationPickerDialog {
    constructor(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.result = new DurationPickerDialogResult();
        this.state = data.state;
    }
    onValueChange(field) {
        console.log('DurationPickerDialog', 'onValueChange', field);
    }
    onCancelRequest() {
        this.dialogRef.close(this.result);
    }
    onOkRequest() {
        this.result.success = true;
        this.result.millis = this.state.millis;
        this.dialogRef.close(this.result);
    }
}
exports.DurationPickerDialog = DurationPickerDialog;
DurationPickerDialog.ɵfac = function DurationPickerDialog_Factory(t) { return new (t || DurationPickerDialog)(i0.ɵɵdirectiveInject(i1.MatDialogRef), i0.ɵɵdirectiveInject(dialog_1.MAT_DIALOG_DATA)); };
DurationPickerDialog.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: DurationPickerDialog, selectors: [["duration-picker-dialog"]], hostVars: 3, hostBindings: function DurationPickerDialog_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵattribute("flex", ctx.flex)("layout", ctx.flexLayout)("layout-align", ctx.flexLayoutAlign);
    } }, decls: 9, vars: 1, consts: [["flex", "", "layout", "column", "layout-align", "start", 1, "tanj-duration-picker-dialog-body"], ["flex", "", "layout", "row", "layout-align", "space-around", 1, ""], ["flex", "", 3, "ngModel", "label", "labelPosition", "max", "min", "ngModelChange", "change", 4, "ngFor", "ngForOf"], ["layout", "column", "layout-align", "end"], ["flex", "", "layout", "row", "layout-align", "center", 1, "tanj-button-footer"], ["flex", "", "mat-raised-button", "", "color", "accent", 1, "tanj-cancel", 3, "click"], ["flex", "", "mat-raised-button", "", "color", "primary", 1, "tanj-ok", 3, "click"], ["flex", "", 3, "ngModel", "label", "labelPosition", "max", "min", "ngModelChange", "change"]], template: function DurationPickerDialog_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementStart(0, "div", 0)(1, "div", 1);
        i0.ɵɵtemplate(2, DurationPickerDialog_tanj_number_spinner_widget_2_Template, 1, 5, "tanj-number-spinner-widget", 2);
        i0.ɵɵelementEnd()();
        i0.ɵɵelementStart(3, "div", 3)(4, "div", 4)(5, "a", 5);
        i0.ɵɵlistener("click", function DurationPickerDialog_Template_a_click_5_listener() { return ctx.onCancelRequest(); });
        i0.ɵɵtext(6, "Cancel");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(7, "a", 6);
        i0.ɵɵlistener("click", function DurationPickerDialog_Template_a_click_7_listener() { return ctx.onOkRequest(); });
        i0.ɵɵtext(8, "Set");
        i0.ɵɵelementEnd()()();
    } if (rf & 2) {
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngForOf", ctx.state.selectedFields());
    } }, dependencies: [i2.NgForOf, i3.NgControlStatus, i3.NgModel, i4.NumberSpinnerWidgetComponent], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(DurationPickerDialog, [{
        type: core_1.Component,
        args: [{ selector: 'duration-picker-dialog', encapsulation: core_1.ViewEncapsulation.None, template: "<div flex class=\"tanj-duration-picker-dialog-body\" layout=\"column\" layout-align=\"start\">\n  <div flex class=\"\" layout=\"row\" layout-align=\"space-around\">\n\n    <tanj-number-spinner-widget flex *ngFor=\"let field of state.selectedFields()\"\n                               [(ngModel)]=\"field.value\"\n                               [label]=\"field.label\"\n                               [labelPosition]=\"'below'\"\n                               [max]=\"field.max\"\n                               [min]=\"0\"\n                               (change)=\"onValueChange(field)\"></tanj-number-spinner-widget>\n  </div>\n</div>\n<div layout=\"column\" layout-align=\"end\">\n  <div flex class='tanj-button-footer' layout=\"row\" layout-align=\"center\">\n    <a flex mat-raised-button color=\"accent\" class=\"tanj-cancel\" (click)=\"onCancelRequest()\">Cancel</a>\n    <a flex mat-raised-button color=\"primary\" class=\"tanj-ok\" (click)=\"onOkRequest()\">Set</a>\n  </div>\n</div>\n\n" }]
    }], function () { return [{ type: i1.MatDialogRef }, { type: undefined, decorators: [{
                type: core_1.Inject,
                args: [dialog_1.MAT_DIALOG_DATA]
            }] }]; }, { flex: [{
            type: core_1.HostBinding,
            args: ['attr.flex']
        }], flexLayout: [{
            type: core_1.HostBinding,
            args: ['attr.layout']
        }], flexLayoutAlign: [{
            type: core_1.HostBinding,
            args: ['attr.layout-align']
        }] }); })();
//# sourceMappingURL=duration-picker-dialog.js.map