"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IconRatingWidgetComponent = exports.IconRatingWidgetChange = exports.TANJ_ICON_RATING_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = void 0;
const core_1 = require("@angular/core");
const forms_1 = require("@angular/forms");
const core_2 = require("@tangential/core");
const i0 = require("@angular/core");
const i1 = require("@angular/common");
const i2 = require("../../components/icon/icon.component");
function IconRatingWidgetComponent_span_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 6);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r0.label);
} }
function IconRatingWidgetComponent_div_3_tanj_icon_2_Template(rf, ctx) { if (rf & 1) {
    const _r8 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "tanj-icon", 10);
    i0.ɵɵlistener("click", function IconRatingWidgetComponent_div_3_tanj_icon_2_Template_tanj_icon_click_0_listener() { const restoredCtx = i0.ɵɵrestoreView(_r8); const idx_r6 = restoredCtx.index; const ctx_r7 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r7.onIconClick(idx_r6)); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const icon_r5 = ctx.$implicit;
    i0.ɵɵproperty("icon", icon_r5);
} }
function IconRatingWidgetComponent_div_3_Template(rf, ctx) { if (rf & 1) {
    const _r10 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 7);
    i0.ɵɵlistener("swipeRight", function IconRatingWidgetComponent_div_3_Template_div_swipeRight_0_listener($event) { i0.ɵɵrestoreView(_r10); const ctx_r9 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r9.swipeRight($event)); })("swipeLeft", function IconRatingWidgetComponent_div_3_Template_div_swipeLeft_0_listener($event) { i0.ɵɵrestoreView(_r10); const ctx_r11 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r11.swipeLeft($event)); });
    i0.ɵɵelementStart(1, "div", 8);
    i0.ɵɵtemplate(2, IconRatingWidgetComponent_div_3_tanj_icon_2_Template, 1, 1, "tanj-icon", 9);
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngForOf", ctx_r1.icons);
} }
function IconRatingWidgetComponent_span_4_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 11);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r2 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r2.label);
} }
function IconRatingWidgetComponent_span_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 12);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r3 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r3.label);
} }
const _c0 = function (a0) { return { "tanj-disabled": a0 }; };
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_ICON_RATING_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: (0, core_1.forwardRef)(() => IconRatingWidgetComponent),
    multi: true
};
class IconRatingWidgetChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
exports.IconRatingWidgetChange = IconRatingWidgetChange;
class IconRatingWidgetComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = 0;
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        this.hideLabel = false;
        this.onlyLabel = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = 0;
        this.max = 5;
        this.offIconNames = [];
        this.onIconNames = [];
        /* end Configuration Fields */
        this.change = new core_1.EventEmitter(false);
        this.icons = [];
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
        if (this.max && this.iconFont && this.offIconNames && this.onIconNames) {
            this.icons = [];
            for (let i = 0; i < this.max; i++) {
                const icon = {
                    font: this.iconFont,
                    name: i <= this.value ? this.onIconNames[0] : this.offIconNames[0]
                    //                           star                 star_border
                };
                this.icons.push(icon);
            }
        }
    }
    onIconClick(idx) {
        if (!this.disabled) {
            this.value = idx;
            this.valueChange.emit(this.value);
        }
    }
    swipeRight(event) {
    }
    swipeLeft(event) {
    }
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new IconRatingWidgetChange(this, this.value));
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
exports.IconRatingWidgetComponent = IconRatingWidgetComponent;
IconRatingWidgetComponent.ɵfac = function IconRatingWidgetComponent_Factory(t) { return new (t || IconRatingWidgetComponent)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef)); };
IconRatingWidgetComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: IconRatingWidgetComponent, selectors: [["tanj-icon-rating-widget"]], hostVars: 3, hostBindings: function IconRatingWidgetComponent_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵattribute("flex", ctx.flex)("layout", ctx.flexLayout)("layout-align", ctx.flexLayoutAlign);
    } }, inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", hideLabel: "hideLabel", onlyLabel: "onlyLabel", label: "label", defaultValue: "defaultValue", max: "max", iconFont: "iconFont", offIconNames: "offIconNames", onIconNames: "onIconNames" }, outputs: { valueChange: "valueChange", change: "change" }, features: [i0.ɵɵProvidersFeature([exports.TANJ_ICON_RATING_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR]), i0.ɵɵNgOnChangesFeature], decls: 6, vars: 7, consts: [["flex", "", "layout", "row", "layout-align", "center center", 1, "tanj-input-template", "tanj-mode-edit", 3, "ngClass"], ["class", "tanj-label tanj-icon-rating-widget-label", 4, "ngIf"], ["flex", "", "layout", "column", "layout-align", "start center", 1, "tanj-widget-input"], ["class", "tanj-icon-rating-stars tanj-widget-input", "layout", "column", "layout-align", "start", 3, "swipeRight", "swipeLeft", 4, "ngIf"], ["class", "tanj-label tanj-below", 4, "ngIf"], ["class", "tanj-label tanj-after tanj-icon-rating-widget-label", 4, "ngIf"], [1, "tanj-label", "tanj-icon-rating-widget-label"], ["layout", "column", "layout-align", "start", 1, "tanj-icon-rating-stars", "tanj-widget-input", 3, "swipeRight", "swipeLeft"], ["flex", "", "layout", "row", "layout-align", "start", 1, "tanj-icon-rating-icons-container"], [3, "icon", "click", 4, "ngFor", "ngForOf"], [3, "icon", "click"], [1, "tanj-label", "tanj-below"], [1, "tanj-label", "tanj-after", "tanj-icon-rating-widget-label"]], template: function IconRatingWidgetComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementStart(0, "div", 0);
        i0.ɵɵtemplate(1, IconRatingWidgetComponent_span_1_Template, 2, 1, "span", 1);
        i0.ɵɵelementStart(2, "div", 2);
        i0.ɵɵtemplate(3, IconRatingWidgetComponent_div_3_Template, 3, 1, "div", 3);
        i0.ɵɵtemplate(4, IconRatingWidgetComponent_span_4_Template, 2, 1, "span", 4);
        i0.ɵɵelementEnd();
        i0.ɵɵtemplate(5, IconRatingWidgetComponent_span_5_Template, 2, 1, "span", 5);
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction1(5, _c0, ctx.disabled));
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", !ctx.hideLabel && ctx.labelPosition == "before");
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngIf", !ctx.onlyLabel);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", !ctx.hideLabel && ctx.labelPosition == "below");
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", !ctx.hideLabel && ctx.labelPosition == "after");
    } }, dependencies: [i1.NgClass, i1.NgForOf, i1.NgIf, i2.IconComponent], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(IconRatingWidgetComponent, [{
        type: core_1.Component,
        args: [{
                selector: 'tanj-icon-rating-widget',
                template: `<!-- -->
  <div flex
       class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="center center">
    <span *ngIf="!hideLabel && labelPosition == 'before'"
          class="tanj-label tanj-icon-rating-widget-label">{{label}}</span>
    <div flex class="tanj-widget-input" layout="column" layout-align="start center">
      <div *ngIf="!onlyLabel"
           class="tanj-icon-rating-stars tanj-widget-input"
           layout="column"
           layout-align="start"
           (swipeRight)="swipeRight($event)"
           (swipeLeft)="swipeLeft($event)">

        <div flex class="tanj-icon-rating-icons-container" layout="row" layout-align="start">
          <tanj-icon *ngFor="let icon of icons; let idx = index" [icon]="icon" (click)="onIconClick(idx)"></tanj-icon>
        </div>

      </div>
      <span *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</span>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-after tanj-icon-rating-widget-label">{{label}}</span>
  </div>
                 `,
                providers: [exports.TANJ_ICON_RATING_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
                encapsulation: core_1.ViewEncapsulation.None
            }]
    }], function () { return [{ type: i0.ChangeDetectorRef }]; }, { flex: [{
            type: core_1.HostBinding,
            args: ['attr.flex']
        }], flexLayout: [{
            type: core_1.HostBinding,
            args: ['attr.layout']
        }], flexLayoutAlign: [{
            type: core_1.HostBinding,
            args: ['attr.layout-align']
        }], value: [{
            type: core_1.Input
        }], valueChange: [{
            type: core_1.Output
        }], labelPosition: [{
            type: core_1.Input
        }], disabled: [{
            type: core_1.Input
        }], hideLabel: [{
            type: core_1.Input
        }], onlyLabel: [{
            type: core_1.Input
        }], label: [{
            type: core_1.Input
        }], defaultValue: [{
            type: core_1.Input
        }], max: [{
            type: core_1.Input
        }], iconFont: [{
            type: core_1.Input
        }], offIconNames: [{
            type: core_1.Input
        }], onIconNames: [{
            type: core_1.Input
        }], change: [{
            type: core_1.Output
        }] }); })();
//# sourceMappingURL=icon-rating-widget.component.js.map