"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SlideToggleWidgetComponent = exports.SlideToggleWidgetChange = exports.TANJ_SLIDE_TOGGLE_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = void 0;
const core_1 = require("@angular/core");
const forms_1 = require("@angular/forms");
const core_2 = require("@tangential/core");
const i0 = require("@angular/core");
const i1 = require("@angular/common");
const i2 = require("@angular/forms");
const i3 = require("@angular/material/slide-toggle");
function SlideToggleWidgetComponent_span_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 5);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r0.label);
} }
function SlideToggleWidgetComponent_div_3_Template(rf, ctx) { if (rf & 1) {
    const _r5 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 6)(1, "mat-slide-toggle", 7);
    i0.ɵɵlistener("ngModelChange", function SlideToggleWidgetComponent_div_3_Template_mat_slide_toggle_ngModelChange_1_listener($event) { i0.ɵɵrestoreView(_r5); const ctx_r4 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r4.value = $event); })("change", function SlideToggleWidgetComponent_div_3_Template_mat_slide_toggle_change_1_listener() { i0.ɵɵrestoreView(_r5); const ctx_r6 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r6.handleValueChange(ctx_r6.value)); });
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵproperty("disabled", ctx_r1.disabled)("ngModel", ctx_r1.value);
} }
function SlideToggleWidgetComponent_div_4_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 8);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r2 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r2.label);
} }
function SlideToggleWidgetComponent_span_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 5);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r3 = i0.ɵɵnextContext();
    i0.ɵɵadvance(1);
    i0.ɵɵtextInterpolate(ctx_r3.label);
} }
const _c0 = function (a0) { return { "tanj-disabled": a0 }; };
/**
 * Provider Expression that allows this widget to register as a ControlValueAccessor.
 * This allows it to support [(ngModel)].
 * @docs-private
 */
exports.TANJ_SLIDE_TOGGLE_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR = {
    provide: forms_1.NG_VALUE_ACCESSOR,
    useExisting: (0, core_1.forwardRef)(() => SlideToggleWidgetComponent),
    multi: true
};
class SlideToggleWidgetChange {
    constructor(source, value) {
        this.source = source;
        this.value = value;
    }
}
exports.SlideToggleWidgetChange = SlideToggleWidgetChange;
class SlideToggleWidgetComponent {
    constructor(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        // turn this into a class
        this.flex = '';
        this.flexLayout = 'column';
        this.flexLayoutAlign = 'start';
        this.value = false;
        this.valueChange = new core_1.EventEmitter(false);
        this.labelPosition = 'before';
        this.disabled = false;
        this.hideLabel = false;
        this.onlyLabel = false;
        /**
         * Configuration Fields
         */
        this.label = '';
        this.defaultValue = false;
        /* end Configuration Fields */
        this.change = new core_1.EventEmitter(false);
        this.onTouched = () => { };
        this.controlValueAccessorChangeFn = (value) => { };
    }
    ngOnInit() {
        core_2.Hacks.materialDesignPlaceholderText(this.changeDetectorRef);
    }
    ngOnChanges(changes) {
    }
    handleValueChange(value) {
        if (!this.disabled) {
            this.value = value;
            this.valueChange.emit(this.value);
            this.emitChangeEvent();
        }
    }
    /**
     * Boilerplate / required for Angular
     *
     */
    emitChangeEvent() {
        this.controlValueAccessorChangeFn(this.value);
        this.change.emit(new SlideToggleWidgetChange(this, this.value));
    }
    writeValue(value) {
        this.value = value;
    }
    registerOnChange(fn) {
        this.controlValueAccessorChangeFn = fn;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    /**
     * Sets the input's disabled state. Implemented as a part of ControlValueAccessor.
     * @param isDisabled Whether the input should be disabled.
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
}
exports.SlideToggleWidgetComponent = SlideToggleWidgetComponent;
SlideToggleWidgetComponent.ɵfac = function SlideToggleWidgetComponent_Factory(t) { return new (t || SlideToggleWidgetComponent)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef)); };
SlideToggleWidgetComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SlideToggleWidgetComponent, selectors: [["tanj-slide-toggle-widget"]], hostVars: 3, hostBindings: function SlideToggleWidgetComponent_HostBindings(rf, ctx) { if (rf & 2) {
        i0.ɵɵattribute("flex", ctx.flex)("layout", ctx.flexLayout)("layout-align", ctx.flexLayoutAlign);
    } }, inputs: { value: "value", labelPosition: "labelPosition", disabled: "disabled", hideLabel: "hideLabel", onlyLabel: "onlyLabel", label: "label", defaultValue: "defaultValue" }, outputs: { valueChange: "valueChange", change: "change" }, features: [i0.ɵɵProvidersFeature([exports.TANJ_SLIDE_TOGGLE_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR]), i0.ɵɵNgOnChangesFeature], decls: 6, vars: 7, consts: [["flex", "", "layout", "row", "layout-align", "center center", 1, "tanj-input-template", "tanj-mode-edit", 3, "ngClass"], ["class", "tanj-label tanj-slide-toggle-widget-label", 4, "ngIf"], ["flex", "", "layout", "column", "layout-align", "start center"], ["class", "tanj-widget-input", "layout", "column", "layout-align", "start", 4, "ngIf"], ["class", "tanj-label tanj-below", 4, "ngIf"], [1, "tanj-label", "tanj-slide-toggle-widget-label"], ["layout", "column", "layout-align", "start", 1, "tanj-widget-input"], ["flex", "", 3, "disabled", "ngModel", "ngModelChange", "change"], [1, "tanj-label", "tanj-below"]], template: function SlideToggleWidgetComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementStart(0, "div", 0);
        i0.ɵɵtemplate(1, SlideToggleWidgetComponent_span_1_Template, 2, 1, "span", 1);
        i0.ɵɵelementStart(2, "div", 2);
        i0.ɵɵtemplate(3, SlideToggleWidgetComponent_div_3_Template, 2, 2, "div", 3);
        i0.ɵɵtemplate(4, SlideToggleWidgetComponent_div_4_Template, 2, 1, "div", 4);
        i0.ɵɵelementEnd();
        i0.ɵɵtemplate(5, SlideToggleWidgetComponent_span_5_Template, 2, 1, "span", 1);
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵproperty("ngClass", i0.ɵɵpureFunction1(5, _c0, ctx.disabled));
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", !ctx.hideLabel && ctx.labelPosition == "before");
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngIf", !ctx.onlyLabel);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", !ctx.hideLabel && ctx.labelPosition == "below");
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", !ctx.hideLabel && ctx.labelPosition == "after");
    } }, dependencies: [i1.NgClass, i1.NgIf, i2.NgControlStatus, i2.NgModel, i3.MatSlideToggle], encapsulation: 2 });
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SlideToggleWidgetComponent, [{
        type: core_1.Component,
        args: [{
                selector: 'tanj-slide-toggle-widget',
                template: `<!-- -->
  <div flex class="tanj-input-template tanj-mode-edit"
       [ngClass]="{'tanj-disabled': disabled}"
       layout="row"
       layout-align="center center">
    <span *ngIf="!hideLabel && labelPosition == 'before'"
          class="tanj-label tanj-slide-toggle-widget-label">{{label}}</span>
    <div flex layout="column" layout-align="start center">
      <div *ngIf="!onlyLabel"
           class="tanj-widget-input"
           layout="column"
           layout-align="start">
        <mat-slide-toggle flex
                         [disabled]="disabled"
                         [(ngModel)]="value"
                         (change)="handleValueChange(value)">
        </mat-slide-toggle>
      </div>
      <div *ngIf="!hideLabel && labelPosition == 'below'" class="tanj-label tanj-below">{{label}}</div>
    </div>
    <span *ngIf="!hideLabel && labelPosition == 'after'" class="tanj-label tanj-slide-toggle-widget-label">{{label}}</span>
  </div>
                 `,
                providers: [exports.TANJ_SLIDE_TOGGLE_WIDGET_VIEW_CONTROL_VALUE_ACCESSOR],
                encapsulation: core_1.ViewEncapsulation.None
            }]
    }], function () { return [{ type: i0.ChangeDetectorRef }]; }, { flex: [{
            type: core_1.HostBinding,
            args: ['attr.flex']
        }], flexLayout: [{
            type: core_1.HostBinding,
            args: ['attr.layout']
        }], flexLayoutAlign: [{
            type: core_1.HostBinding,
            args: ['attr.layout-align']
        }], value: [{
            type: core_1.Input
        }], valueChange: [{
            type: core_1.Output
        }], labelPosition: [{
            type: core_1.Input
        }], disabled: [{
            type: core_1.Input
        }], hideLabel: [{
            type: core_1.Input
        }], onlyLabel: [{
            type: core_1.Input
        }], label: [{
            type: core_1.Input
        }], defaultValue: [{
            type: core_1.Input
        }], change: [{
            type: core_1.Output
        }] }); })();
//# sourceMappingURL=slide-toggle-widget.component.js.map